Index: nagiosplug/trunk/plugins/check_smtp.c
===================================================================
--- nagiosplug/trunk/plugins/check_smtp.c	(revision 2081)
+++ nagiosplug/trunk/plugins/check_smtp.c	(working copy)
@@ -103,9 +103,9 @@
 char *authtype = NULL;
 char *authuser = NULL;
 char *authpass = NULL;
-int warning_time = 0;
+double warning_time = 0;
 int check_warning_time = FALSE;
-int critical_time = 0;
+double critical_time = 0;
 int check_critical_time = FALSE;
 int verbose = 0;
 int use_ssl = FALSE;
@@ -432,9 +432,9 @@
 	elapsed_time = (double)microsec / 1.0e6;
 
 	if (result == STATE_OK) {
-		if (check_critical_time && elapsed_time > (double) critical_time)
+		if (check_critical_time && elapsed_time > critical_time)
 			result = STATE_CRITICAL;
-		else if (check_warning_time && elapsed_time > (double) warning_time)
+		else if (check_warning_time && elapsed_time > warning_time)
 			result = STATE_WARNING;
 	}
 
@@ -565,21 +565,21 @@
 			nresponses++;
 			break;
 		case 'c':									/* critical time threshold */
-			if (is_intnonneg (optarg)) {
-				critical_time = atoi (optarg);
+			if (is_nonnegative (optarg)) {
+				critical_time = strtod( optarg, NULL );
 				check_critical_time = TRUE;
 			}
 			else {
-				usage4 (_("Critical time must be a positive integer"));
+				usage4 (_("Critical time must be a positive number"));
 			}
 			break;
 		case 'w':									/* warning time threshold */
-			if (is_intnonneg (optarg)) {
-				warning_time = atoi (optarg);
+			if (is_nonnegative (optarg)) {
+				warning_time = strtod( optarg, NULL );
 				check_warning_time = TRUE;
 			}
 			else {
-				usage4 (_("Warning time must be a positive integer"));
+				usage4 (_("Warning time must be a positive number"));
 			}
 			break;
 		case 'v':									/* verbose */
